openshot::EffectBase Class Referenceabstract

This abstract class is the base class, used by all effects in libopenshot. More...

`#include <EffectBase.h>`

Inheritance diagram for openshot::EffectBase:

## Public Member Functions

int | constrain (int color_value)
| Constrain a color value from 0 to 255. More...
void | DisplayInfo ()
| Display effect information in the standard output stream (stdout) More...
virtual std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number)=0
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object. More...
void | InitEffectInfo ()
virtual std::string | Json () const =0
| Get and Set JSON methods. More...
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info. More...
virtual Json::Value | JsonValue () const =0
| Generate Json::Value for this object. More...
int | Order () const
| Get the order that this effect should be executed. More...
void | Order (int new_order)
| Set the order that this effect should be executed. More...
virtual void | SetJson (const std::string value)=0
| Load JSON string into this object. More...
virtual void | SetJsonValue (const Json::Value root)=0
| Load Json::Value into this object. More...
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip. More...
float | Duration () const
| Get the length of this clip (in seconds) More...
float | End () const
| Get end position (in seconds) of clip (trim end of video) More...
void | End (float value)
| Set end position (in seconds) of clip (trim end of video) More...
std::string | Id () const
| Get basic properties. More...
void | Id (std::string value)
| Set basic properties. More...
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers) More...
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers) More...
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
float | Position () const
| Get position on timeline (in seconds) More...
void | Position (float value)

> Set the Id of this clip object

More...

virtual std::string | PropertiesJSON (int64_t requested_frame) const =0
float | Start () const
| Get start position (in seconds) of clip (trim start of video) More...
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video) More...
virtual | ~ClipBase ()=default

## Public Attributes

EffectInfoStruct | info
| Information about the current effect. More...

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties) More...
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property. More...
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip) More...
std::string | id
| ID Property for all derived Clip and Effect classes. More...
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips. More...
float | position
| The position on the timeline where this clip should start playing. More...
std::string | previous_properties
| This string contains the previous JSON properties. More...
float | start
| The position in seconds to start playing (used to trim the beginning of a clip) More...

## Detailed Description

This abstract class is the base class, used by all effects in libopenshot.

Effects are types of classes that manipulate the image or audio data of an openshot::Frame object. The only requirements for an 'effect', is to derive from this base class, implement the Apply() method, and call the InitEffectInfo() method.

Definition at line 66 of file EffectBase.h.

## Constructor & Destructor Documentation

## ~EffectBase()

virtual openshot::EffectBase::~EffectBase | ( |  | ) |

virtual default

## Member Function Documentation

## constrain()

int EffectBase::constrain | ( | int | color_value | ) |

Constrain a color value from 0 to 255.

Definition at line 65 of file EffectBase.cpp.

Referenced by openshot::Brightness::GetFrame(), openshot::Hue::GetFrame(), openshot::Mask::GetFrame(), and openshot::Saturation::GetFrame().

## DisplayInfo()

void EffectBase::DisplayInfo | ( |  | ) |

Display effect information in the standard output stream (stdout)

Definition at line 52 of file EffectBase.cpp.

## GetFrame()

virtual std::shared_ptr<openshot::Frame> openshot::EffectBase::GetFrame | ( | std::shared_ptr< openshot::Frame > | frame,
|  | int64_t | frame_number
| ) |  |

pure virtual

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from its keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Implemented in openshot::Wave, openshot::Shift, openshot::Saturation, openshot::Pixelate, openshot::Negate, openshot::Mask, openshot::Hue, openshot::Deinterlace, openshot::Crop, openshot::ColorShift, openshot::ChromaKey, openshot::Brightness, openshot::Blur, and openshot::Bars.

## InitEffectInfo()

void EffectBase::InitEffectInfo | ( |  | ) |

Initialize the values of the EffectInfo struct. It is important for derived classes to call this method, or the EffectInfo struct values will not be initialized.

Definition at line 36 of file EffectBase.cpp.

Referenced by openshot::Negate::Negate().

## Json()

std::string EffectBase::Json | ( |  | ) | const

pure virtual

Get and Set JSON methods.

Generate JSON string of this object

Implements openshot::ClipBase.

Implemented in openshot::Wave, openshot::Shift, openshot::Saturation, openshot::Pixelate, openshot::Negate, openshot::Mask, openshot::Hue, openshot::Deinterlace, openshot::Crop, openshot::ColorShift, openshot::ChromaKey, openshot::Brightness, openshot::Blur, and openshot::Bars.

Definition at line 77 of file EffectBase.cpp.

## JsonInfo()

Json::Value EffectBase::JsonInfo | ( |  | ) | const

Generate JSON object of meta data / info.

Definition at line 128 of file EffectBase.cpp.

## JsonValue()

Json::Value EffectBase::JsonValue | ( |  | ) | const

pure virtual

Generate Json::Value for this object.

Implements openshot::ClipBase.

Implemented in openshot::Wave, openshot::Shift, openshot::Saturation, openshot::Pixelate, openshot::Negate, openshot::Mask, openshot::Hue, openshot::Deinterlace, openshot::Crop, openshot::ColorShift, openshot::ChromaKey, openshot::Brightness, openshot::Blur, and openshot::Bars.

Definition at line 84 of file EffectBase.cpp.

Referenced by Json(), openshot::Bars::JsonValue(), openshot::Blur::JsonValue(), openshot::Brightness::JsonValue(), openshot::ChromaKey::JsonValue(), openshot::ColorShift::JsonValue(), openshot::Crop::JsonValue(), openshot::Deinterlace::JsonValue(), openshot::Hue::JsonValue(), openshot::Mask::JsonValue(), openshot::Negate::JsonValue(), openshot::Pixelate::JsonValue(), openshot::Saturation::JsonValue(), openshot::Shift::JsonValue(), and openshot::Wave::JsonValue().

## Order() [1/2]

int openshot::EffectBase::Order | ( |  | ) | const

inline

Get the order that this effect should be executed.

Definition at line 104 of file EffectBase.h.

Referenced by InitEffectInfo(), JsonValue(), openshot::CompareEffects::operator()(), openshot::CompareClipEffects::operator()(), and SetJsonValue().

## Order() [2/2]

void openshot::EffectBase::Order | ( | int | new_order | ) |

inline

Set the order that this effect should be executed.

Definition at line 107 of file EffectBase.h.

## SetJson()

void EffectBase::SetJson | ( | const std::string | value | ) |

pure virtual

Load JSON string into this object.

Implements openshot::ClipBase.

Implemented in openshot::Wave, openshot::Shift, openshot::Saturation, openshot::Pixelate, openshot::Negate, openshot::Mask, openshot::Hue, openshot::Deinterlace, openshot::Crop, openshot::ColorShift, openshot::ChromaKey, openshot::Brightness, openshot::Blur, and openshot::Bars.

Definition at line 100 of file EffectBase.cpp.

## SetJsonValue()

void EffectBase::SetJsonValue | ( | const Json::Value | root | ) |

pure virtual

Load Json::Value into this object.

Implements openshot::ClipBase.

Implemented in openshot::Wave, openshot::Shift, openshot::Saturation, openshot::Pixelate, openshot::Negate, openshot::Mask, openshot::Hue, openshot::Deinterlace, openshot::Crop, openshot::ColorShift, openshot::ChromaKey, openshot::Brightness, openshot::Blur, and openshot::Bars.

Definition at line 117 of file EffectBase.cpp.

Referenced by SetJson(), openshot::Clip::SetJsonValue(), openshot::Bars::SetJsonValue(), openshot::Blur::SetJsonValue(), openshot::Brightness::SetJsonValue(), openshot::ChromaKey::SetJsonValue(), openshot::ColorShift::SetJsonValue(), openshot::Crop::SetJsonValue(), openshot::Deinterlace::SetJsonValue(), openshot::Hue::SetJsonValue(), openshot::Mask::SetJsonValue(), openshot::Negate::SetJsonValue(), openshot::Pixelate::SetJsonValue(), openshot::Saturation::SetJsonValue(), openshot::Shift::SetJsonValue(), openshot::Wave::SetJsonValue(), and openshot::Timeline::SetJsonValue().

## Member Data Documentation

## info

EffectInfoStruct openshot::EffectBase::info

Information about the current effect.

Definition at line 73 of file EffectBase.h.

Referenced by DisplayInfo(), InitEffectInfo(), JsonInfo(), JsonValue(), openshot::Bars::JsonValue(), openshot::Blur::JsonValue(), openshot::Brightness::JsonValue(), openshot::ChromaKey::JsonValue(), openshot::ColorShift::JsonValue(), openshot::Crop::JsonValue(), openshot::Deinterlace::JsonValue(), openshot::Hue::JsonValue(), openshot::Mask::JsonValue(), openshot::Negate::JsonValue(), openshot::Pixelate::JsonValue(), openshot::Saturation::JsonValue(), openshot::Shift::JsonValue(), openshot::Wave::JsonValue(), and openshot::Negate::Negate().

The documentation for this class was generated from the following files:

- EffectBase.h
- EffectBase.cpp